(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('rxjs'), require('rxjs/operators')) :
    typeof define === 'function' && define.amd ? define('hg-async-render', ['exports', '@angular/core', '@angular/common', 'rxjs', 'rxjs/operators'], factory) :
    (global = global || self, factory(global['hg-async-render'] = {}, global.ng.core, global.ng.common, global.rxjs, global.rxjs.operators));
}(this, (function (exports, core, common, rxjs, operators) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __exportStar(m, exports) {
        for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
        if (m) return m.call(o);
        return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var HG_ASYNC_RENDER_RESOLVER = new core.InjectionToken('HG_ASYNC_RENDER_RESOLVER');
    /** @enum {number} */
    var ResolverConfig = {
        Default: 0,
        AutoResolveOnce: 1,
        AutoResolve: 2,
    };
    ResolverConfig[ResolverConfig.Default] = 'Default';
    ResolverConfig[ResolverConfig.AutoResolveOnce] = 'AutoResolveOnce';
    ResolverConfig[ResolverConfig.AutoResolve] = 'AutoResolve';
    /**
     * @record
     * @template D
     */
    function IActionsTarget() { }
    if (false) {
        /** @type {?} */
        IActionsTarget.prototype.loadAction;
        /** @type {?} */
        IActionsTarget.prototype.cancelAction;
        /** @type {?} */
        IActionsTarget.prototype.success$;
        /** @type {?} */
        IActionsTarget.prototype.failure$;
    }
    /**
     * @template T, D
     */
    var   /**
     * @template T, D
     */
    AsyncRenderResolver = /** @class */ (function () {
        function AsyncRenderResolver(targetFn, dependencies) {
            if (dependencies === void 0) { dependencies = null; }
            this.targetFn = targetFn;
            this.dependencies = dependencies;
            this.config = ResolverConfig.Default;
            // tslint:disable-next-line:variable-name
            this._isAlive$ = new rxjs.Subject();
            // tslint:disable-next-line:variable-name
            this._shouldSkip = null;
            // tslint:disable-next-line:variable-name
            this._autoResolveOnceCompleted = false;
            // tslint:disable-next-line:variable-name
            this._resolveRequested = false;
            // tslint:disable-next-line:variable-name
            this._state = { loading: false, errored: false };
            // tslint:disable-next-line:variable-name
            this._data$ = new rxjs.ReplaySubject(1);
            // tslint:disable-next-line:variable-name
            this._dataObservable$ = this._data$.asObservable();
        }
        Object.defineProperty(AsyncRenderResolver.prototype, "isLoading", {
            get: /**
             * @return {?}
             */
            function () { return this._state.loading; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AsyncRenderResolver.prototype, "hasErrored", {
            get: /**
             * @return {?}
             */
            function () { return this._state.errored; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AsyncRenderResolver.prototype, "data$", {
            get: /**
             * @return {?}
             */
            function () {
                if (this.isFunctionObservableTarget) {
                    return this._dataObservable$;
                }
                // tslint:disable-next-line:max-line-length
                console.warn('hg-async-render: Action based async render resolvers don\'t have data$ property! Data management should be controlled via action handlers!');
                return undefined;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AsyncRenderResolver.prototype, "shouldSkip", {
            get: /**
             * @return {?}
             */
            function () {
                return this._shouldSkip;
            },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                if (value === true && !this._shouldSkip) {
                    if (!!this._functionObservableSubscription) {
                        this._functionObservableSubscription.unsubscribe();
                        this._functionObservableSubscription = undefined;
                    }
                    else if (!!this._dependencySubscription) {
                        this._dependencySubscription.unsubscribe();
                        this._dependencySubscription = undefined;
                    }
                    this._resolveRequested = false;
                    this._state.errored = false;
                    this._state.loading = false;
                }
                /** @type {?} */
                var shouldAutoResolveOnce = (this.config === ResolverConfig.AutoResolveOnce && this._autoResolveOnceCompleted === false);
                if (((this.config === ResolverConfig.AutoResolve && this._shouldSkip === true) ||
                    (shouldAutoResolveOnce && this._shouldSkip)) && value === false) {
                    // asapScheduler.schedule(() => { this.resolve(true); });
                    this.resolve(true);
                }
                this._shouldSkip = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AsyncRenderResolver.prototype, "isFunctionObservableTarget", {
            get: /**
             * @private
             * @return {?}
             */
            function () {
                return this.targetFn instanceof Function;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?=} auto
         * @return {?}
         */
        AsyncRenderResolver.prototype.resolve = /**
         * @param {?=} auto
         * @return {?}
         */
        function (auto) {
            var _this = this;
            if (auto === void 0) { auto = false; }
            if (this._resolveRequested || (auto && this._autoResolveOnceCompleted)) {
                return;
            }
            this._resolveRequested = true;
            if (this._dependencySubscription) {
                this._dependencySubscription.unsubscribe();
            }
            /** @type {?} */
            var isAutoResolveOnceConfig = this.config === ResolverConfig.AutoResolveOnce;
            /** @type {?} */
            var isDefaultConfig = this.config === ResolverConfig.Default;
            if (isAutoResolveOnceConfig) {
                this._autoResolveOnceCompleted = true;
            }
            rxjs.asapScheduler.schedule((/**
             * @return {?}
             */
            function () {
                _this._state.errored = false;
                _this._state.loading = true;
                _this.error = undefined;
                /** @type {?} */
                var dependencies = _this.dependencies;
                if (typeof _this.dependencies === 'function') {
                    dependencies = _this.dependencies();
                    if (Array.isArray(dependencies)) {
                        dependencies = [dependencies];
                    }
                }
                /** @type {?} */
                var deps = !dependencies ? rxjs.of(undefined) : rxjs.combineLatest(dependencies).pipe((isAutoResolveOnceConfig || isDefaultConfig) ? operators.first() : operators.takeUntil(_this._isAlive$));
                _this._dependencySubscription = deps.subscribe((/**
                 * @param {?} data
                 * @return {?}
                 */
                function (data) {
                    _this._resolveRequested = false;
                    rxjs.asapScheduler.schedule((/**
                     * @return {?}
                     */
                    function () {
                        _this._state.errored = false;
                        _this._state.loading = true;
                    }));
                    if (!_this.isFunctionObservableTarget) {
                        /** @type {?} */
                        var target = (/** @type {?} */ (_this.targetFn));
                        target.loadAction(data);
                        target.success$.pipe(operators.first(), operators.takeUntil(_this._isAlive$)).subscribe((/**
                         * @return {?}
                         */
                        function () {
                            _this._state.loading = false;
                            _this._state.errored = false;
                        }));
                        target.failure$.pipe(operators.first(), operators.takeUntil(_this._isAlive$)).subscribe((/**
                         * @return {?}
                         */
                        function () {
                            _this._state.loading = false;
                            _this._state.errored = true;
                        }));
                    }
                    else {
                        /** @type {?} */
                        var targetFn = (/** @type {?} */ (_this.targetFn));
                        if (_this._functionObservableSubscription) {
                            _this._functionObservableSubscription.unsubscribe();
                            _this._functionObservableSubscription = undefined;
                        }
                        _this._functionObservableSubscription = targetFn(data).pipe(operators.takeUntil(_this._isAlive$)).subscribe({
                            next: (/**
                             * @param {?} res
                             * @return {?}
                             */
                            function (res) {
                                _this._data$.next(res);
                                _this._state.loading = false;
                                _this._state.errored = false;
                            }),
                            error: (/**
                             * @param {?} err
                             * @return {?}
                             */
                            function (err) {
                                _this.error = err;
                                _this._state.loading = false;
                                _this._state.errored = true;
                            }),
                            complete: (/**
                             * @return {?}
                             */
                            function () {
                                _this._state.loading = false;
                                _this._state.errored = false;
                                _this._functionObservableSubscription = undefined;
                            })
                        });
                    }
                }));
            }));
        };
        /**
         * @return {?}
         */
        AsyncRenderResolver.prototype.destroy = /**
         * @return {?}
         */
        function () {
            this._isAlive$.next();
            this._isAlive$.complete();
            if (!this._state.loading) {
                return;
            }
            /** @type {?} */
            var target = (/** @type {?} */ (this.targetFn));
            if (target.cancelAction) {
                target.cancelAction();
            }
        };
        return AsyncRenderResolver;
    }());
    if (false) {
        /**
         * @type {?}
         * @protected
         */
        AsyncRenderResolver.prototype.config;
        /**
         * @type {?}
         * @private
         */
        AsyncRenderResolver.prototype._isAlive$;
        /**
         * @type {?}
         * @private
         */
        AsyncRenderResolver.prototype._shouldSkip;
        /**
         * @type {?}
         * @private
         */
        AsyncRenderResolver.prototype._autoResolveOnceCompleted;
        /**
         * @type {?}
         * @private
         */
        AsyncRenderResolver.prototype._dependencySubscription;
        /**
         * @type {?}
         * @private
         */
        AsyncRenderResolver.prototype._resolveRequested;
        /**
         * @type {?}
         * @private
         */
        AsyncRenderResolver.prototype._state;
        /**
         * @type {?}
         * @private
         */
        AsyncRenderResolver.prototype._data$;
        /**
         * @type {?}
         * @private
         */
        AsyncRenderResolver.prototype._dataObservable$;
        /**
         * @type {?}
         * @private
         */
        AsyncRenderResolver.prototype._functionObservableSubscription;
        /** @type {?} */
        AsyncRenderResolver.prototype.error;
        /**
         * @type {?}
         * @private
         */
        AsyncRenderResolver.prototype.targetFn;
        /**
         * @type {?}
         * @private
         */
        AsyncRenderResolver.prototype.dependencies;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var AsyncRenderBase = /** @class */ (function () {
        function AsyncRenderBase(resolvers) {
            if (resolvers === void 0) { resolvers = []; }
            this.resolvers = resolvers;
            this.resolvers = [].concat(this.resolvers || []);
        }
        Object.defineProperty(AsyncRenderBase.prototype, "isLoading", {
            get: /**
             * @return {?}
             */
            function () {
                return this.resolvers.reduce((/**
                 * @param {?} acc
                 * @param {?} res
                 * @return {?}
                 */
                function (acc, res) { return acc || res.isLoading; }), false);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AsyncRenderBase.prototype, "hasError", {
            get: /**
             * @return {?}
             */
            function () {
                return this.resolvers.reduce((/**
                 * @param {?} acc
                 * @param {?} res
                 * @return {?}
                 */
                function (acc, res) { return acc || res.hasErrored; }), false);
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @protected
         * @return {?}
         */
        AsyncRenderBase.prototype.destroy = /**
         * @protected
         * @return {?}
         */
        function () {
            this.resolvers.forEach((/**
             * @param {?} res
             * @return {?}
             */
            function (res) { return res.destroy(); }));
        };
        /**
         * @return {?}
         */
        AsyncRenderBase.prototype.resolve = /**
         * @return {?}
         */
        function () {
            this.resolvers.forEach((/**
             * @param {?} res
             * @return {?}
             */
            function (res) {
                if (res.shouldSkip) {
                    return;
                }
                res.resolve();
            }));
        };
        return AsyncRenderBase;
    }());
    if (false) {
        /**
         * @type {?}
         * @protected
         */
        AsyncRenderBase.prototype.resolvers;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var AsyncRenderComponent = /** @class */ (function (_super) {
        __extends(AsyncRenderComponent, _super);
        function AsyncRenderComponent(resolvers) {
            if (resolvers === void 0) { resolvers = []; }
            var _this = _super.call(this, resolvers) || this;
            _this.refresh$ = new rxjs.Subject();
            _this.autoControlLoader = false;
            _this.autoControlError = false;
            _this.refresh$.subscribe((/**
             * @return {?}
             */
            function () { _this.resolve(); }));
            return _this;
        }
        Object.defineProperty(AsyncRenderComponent.prototype, "errors", {
            get: /**
             * @return {?}
             */
            function () {
                return this.resolvers.map((/**
                 * @param {?} r
                 * @return {?}
                 */
                function (r) { return r.error; }));
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        AsyncRenderComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            this.resolve();
        };
        /**
         * @return {?}
         */
        AsyncRenderComponent.prototype.ngOnDestroy = /**
         * @return {?}
         */
        function () {
            this.refresh$.complete();
            this.destroy();
        };
        AsyncRenderComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'hg-async-render',
                        template: "<ng-container *ngIf=\"loaderTemplateRef && (!autoControlLoader || isLoading)\">\n  <ng-container *ngTemplateOutlet=\"loaderTemplateRef; context: { $implicit: isLoading }\"></ng-container>\n</ng-container>\n<ng-container *ngIf=\"errorTemplateRef && (!autoControlError || hasError)\">\n  <ng-container *ngTemplateOutlet=\"errorTemplateRef; context: { $implicit: hasError, errors: errors }\"></ng-container>\n</ng-container>\n<ng-content></ng-content>",
                        exportAs: 'asyncRender',
                        styles: [":host{position:relative;width:100%;display:inline-block}"]
                    }] }
        ];
        /** @nocollapse */
        AsyncRenderComponent.ctorParameters = function () { return [
            { type: Array, decorators: [{ type: core.Inject, args: [HG_ASYNC_RENDER_RESOLVER,] }, { type: core.Optional }] }
        ]; };
        AsyncRenderComponent.propDecorators = {
            loaderTemplateRef: [{ type: core.Input }],
            errorTemplateRef: [{ type: core.Input }],
            autoControlLoader: [{ type: core.Input }],
            autoControlError: [{ type: core.Input }]
        };
        return AsyncRenderComponent;
    }(AsyncRenderBase));
    if (false) {
        /** @type {?} */
        AsyncRenderComponent.prototype.refresh$;
        /** @type {?} */
        AsyncRenderComponent.prototype.loaderTemplateRef;
        /** @type {?} */
        AsyncRenderComponent.prototype.errorTemplateRef;
        /** @type {?} */
        AsyncRenderComponent.prototype.autoControlLoader;
        /** @type {?} */
        AsyncRenderComponent.prototype.autoControlError;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var AsyncRenderDirective = /** @class */ (function (_super) {
        __extends(AsyncRenderDirective, _super);
        function AsyncRenderDirective(resolvers, viewContainerRef, templateRef) {
            if (resolvers === void 0) { resolvers = []; }
            var _this = _super.call(this, resolvers) || this;
            _this.refresh$ = new rxjs.Subject();
            _this.refresh$.subscribe((/**
             * @return {?}
             */
            function () { _this.resolve(); }));
            if (!!templateRef) {
                viewContainerRef.createEmbeddedView(templateRef, { $implicit: _this });
            }
            return _this;
        }
        /**
         * @return {?}
         */
        AsyncRenderDirective.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            this.resolve();
        };
        /**
         * @return {?}
         */
        AsyncRenderDirective.prototype.ngOnDestroy = /**
         * @return {?}
         */
        function () {
            this.refresh$.complete();
            this.destroy();
        };
        AsyncRenderDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: '[hgAsyncRender]',
                        exportAs: 'asyncRender'
                    },] }
        ];
        /** @nocollapse */
        AsyncRenderDirective.ctorParameters = function () { return [
            { type: Array, decorators: [{ type: core.Inject, args: [HG_ASYNC_RENDER_RESOLVER,] }, { type: core.Optional }] },
            { type: core.ViewContainerRef },
            { type: core.TemplateRef, decorators: [{ type: core.Optional }] }
        ]; };
        return AsyncRenderDirective;
    }(AsyncRenderBase));
    if (false) {
        /** @type {?} */
        AsyncRenderDirective.prototype.refresh$;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var AsyncRenderModule = /** @class */ (function () {
        function AsyncRenderModule() {
        }
        AsyncRenderModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [AsyncRenderComponent, AsyncRenderDirective],
                        imports: [
                            common.CommonModule
                        ],
                        exports: [AsyncRenderComponent, AsyncRenderDirective]
                    },] }
        ];
        return AsyncRenderModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} target
     * @param {?} key
     * @return {?}
     */
    function toObservable(target, key) {
        /** @type {?} */
        var subject = new rxjs.BehaviorSubject(target[key]);
        /** @type {?} */
        var observable = subject.asObservable().pipe(operators.distinctUntilChanged());
        Object.defineProperty(target, key, {
            set: (/**
             * @param {?} value
             * @return {?}
             */
            function (value) { subject.next(value); }),
            get: (/**
             * @return {?}
             */
            function () { return observable; })
        });
    }

    exports.AsyncRenderComponent = AsyncRenderComponent;
    exports.AsyncRenderDirective = AsyncRenderDirective;
    exports.AsyncRenderModule = AsyncRenderModule;
    exports.AsyncRenderResolver = AsyncRenderResolver;
    exports.HG_ASYNC_RENDER_RESOLVER = HG_ASYNC_RENDER_RESOLVER;
    exports.ResolverConfig = ResolverConfig;
    exports.toObservable = toObservable;
    exports.ɵa = AsyncRenderBase;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=hg-async-render.umd.js.map
