import { OnDestroy, TemplateRef, ViewContainerRef, OnInit } from '@angular/core';
import { AsyncRenderResolver } from '../lib/async-render-resolver';
import { AsyncRenderBase } from './async-render-base';
import { Subject } from 'rxjs';
export declare class AsyncRenderDirective extends AsyncRenderBase implements OnInit, OnDestroy {
    refresh$: Subject<void>;
    constructor(resolvers: AsyncRenderResolver<any>[], viewContainerRef: ViewContainerRef, templateRef: TemplateRef<any>);
    ngOnInit(): void;
    ngOnDestroy(): void;
}
