import { OnDestroy, TemplateRef, OnInit } from '@angular/core';
import { Subject } from 'rxjs';
import { AsyncRenderResolver } from '../async-render-resolver';
import { AsyncRenderBase } from '../async-render-base';
export declare class AsyncRenderComponent extends AsyncRenderBase implements OnInit, OnDestroy {
    refresh$: Subject<void>;
    loaderTemplateRef: TemplateRef<any>;
    errorTemplateRef: TemplateRef<any>;
    autoControlLoader: boolean;
    autoControlError: boolean;
    constructor(resolvers?: AsyncRenderResolver<any>[]);
    readonly errors: Error[];
    ngOnInit(): void;
    ngOnDestroy(): void;
}
